import { DEFAULTS } from './defaults';
import { Typeahead } from './typeahead';

interface JQuery<T = null> {
    typeahead(options): JQuery<HTMLElement>;
}

(function ($) {
    // set defaults
    Typeahead.defaults = DEFAULTS;

    // define jquery plugin
    ($.fn as any).typeahead = function (option) {
        var arg = arguments;
        if (typeof option == 'string' && option == 'getActive') {
            return this.data('active');
        }
        return this.each(function () {
            var $this = $(this);
            var data = $this.data('typeahead');
            var options = typeof option == 'object' && option;
            if (!data) {
                $this.data('typeahead', (data = new Typeahead(this, options)));
            }
            if (typeof option == 'string' && data[option]) {
                if (arg.length > 1) {
                    data[option].apply(
                        data,
                        Array.prototype.slice.call(arg, 1)
                    );
                } else {
                    data[option]();
                }
            }
        });
    };

    // define plugin constructor
    ($.fn as any).typeahead.Constructor = Typeahead;

    // enable gloabal data-api handler
    $(document).on(
        'focus.typeahead.data-api',
        '[data-provide="typeahead"]',
        function (e) {
            var $this = $(this);
            if ($this.data('typeahead')) {
                return;
            }
            (<any>$this).typeahead($this.data());
        }
    );
})(jQuery);
